#include "WA.h"
#include "algorytmy.h"
#include <avr/io.h>

void oblicz_sciezke(void)
 {
  unsigned char x,y,koniec;
  //Poszukaj miasta przeciwnika (0x0E)
  for(y=0;y<MAPA_Y;y++)
   {
    for(x=0;x<MAPA_X;x++)
	 {
	  if(mapa[x][y]==MAPA_WROG) break;
	 }
    if(x<MAPA_X) break;
   }
  //Sprawdz czy znalazl miasto wroga
  if(x==MAPA_X || y==MAPA_Y) return;
  //Przypisanie wartosci 1 polozenemu miastu mojemu na 7-2bit
  mapa[x][y]=(1<<2);

  //Poszukaj miasta mojego (0x0F)
  for(y=0;y<MAPA_Y;y++)
   {
    for(x=0;x<MAPA_X;x++)
	 {
	  if(mapa[x][y]==MAPA_MOJE) break;
	 }
    if(x<MAPA_X) break;
   }
  //Sprawdz czy znalazl miasto moje
  if(x==MAPA_X || y==MAPA_Y) return;
  //Moje miasto na mapie jako teren 
  mapa[x][y]=MAPA_TEREN;
 
  //Przelicz mape
  while(1)
   {
    koniec=1;
    for(y=0;y<MAPA_Y;y++)
     {
      for(x=0;x<MAPA_X;x++)
	   {
	    if((mapa[x][y]>>2))
	     {
	      if(x>0 && y>0) 				if((mapa[x-1][y-1]&0xfc)==0 && (mapa[x-1][y-1]&0x03)) mapa[x-1][y-1]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(y>0) 						if((mapa[x-0][y-1]&0xfc)==0 && (mapa[x-0][y-1]&0x03)) mapa[x-0][y-1]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(x<MAPA_X-1 && y>0) 		if((mapa[x+1][y-1]&0xfc)==0 && (mapa[x+1][y-1]&0x03)) mapa[x+1][y-1]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(x>0) 						if((mapa[x-1][y-0]&0xfc)==0 && (mapa[x-1][y-0]&0x03)) mapa[x-1][y-0]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(x<MAPA_X-1) 				if((mapa[x+1][y-0]&0xfc)==0 && (mapa[x+1][y-0]&0x03)) mapa[x+1][y-0]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(x>0 && y<MAPA_Y-1) 		if((mapa[x-1][y+1]&0xfc)==0 && (mapa[x-1][y+1]&0x03)) mapa[x-1][y+1]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(y<MAPA_Y-1) 				if((mapa[x-0][y+1]&0xfc)==0 && (mapa[x-0][y+1]&0x03)) mapa[x-0][y+1]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
		  if(x<MAPA_X-1 && y<MAPA_Y-1) 	if((mapa[x+1][y+1]&0xfc)==0 && (mapa[x+1][y+1]&0x03)) mapa[x+1][y+1]+=(mapa[x][y]&0xfc)+(1<<2),koniec=0;
	     }
	   }
	 }
    if(koniec) break;
   }
 }
//---------------------------------------------------------------------------------------------------------------------

//Wykonywanie ruch po optymalnej sciezce
unsigned char wykonaj_ruch(unsigned char jednostka_id)
 {
  unsigned char x,y,ruch,d;
  x=jednostki_moje[jednostka_id].x;
  y=jednostki_moje[jednostka_id].y;
  d=mapa[x][y];
  if(x>0 && y>0) 				if(mapa[x-1][y-1]<d && mapa[x-1][y-1]>0) d=mapa[x-1][y-1],ruch=RUCH_GL;
  if(y>0) 						if(mapa[x-0][y-1]<d && mapa[x-0][y-1]>0) d=mapa[x-0][y-1],ruch=RUCH_G;
  if(x<MAPA_X-1 && y>0) 		if(mapa[x+1][y-1]<d && mapa[x+1][y-1]>0) d=mapa[x+1][y-1],ruch=RUCH_GP;
  if(x>0) 						if(mapa[x-1][y-0]<d && mapa[x-1][y-0]>0) d=mapa[x-1][y-0],ruch=RUCH_L;
  if(x<MAPA_X-1) 				if(mapa[x+1][y-0]<d && mapa[x+1][y-0]>0) d=mapa[x+1][y-0],ruch=RUCH_P;
  if(x>0 && y<MAPA_Y-1) 		if(mapa[x-1][y+1]<d && mapa[x-1][y+1]>0) d=mapa[x-1][y+1],ruch=RUCH_DL;
  if(y<MAPA_Y-1) 				if(mapa[x-0][y+1]<d && mapa[x-0][y+1]>0) d=mapa[x-0][y+1],ruch=RUCH_D;
  if(x<MAPA_X-1 && y<MAPA_Y-1) 	if(mapa[x+1][y+1]<d && mapa[x+1][y+1]>0) d=mapa[x+1][y+1],ruch=RUCH_DP;
  return(ruch);
 }
//--------------------------------------------------------------------------------------------------------------------- 
