#include <avr/io.h>
#include "komunikacja.h"
#include "system.h"
#include "WA.h"

void komunikacja_init(void)
 {
  //Wlaczylem nadajnki i odbiornik portu szeregowego 737200Hz
  UCSRB=0x18;
  //Ustawic predkosc 115200bit/s
  UBRRL=3;
  //Kasowanie bitu odbioru
  UCSRA|=0x80;
  //Ustawienie licznika do timeout
 }
//-------------------------------------------------------------------------------------------------

unsigned char komunikacja_odbierz(unsigned int timeout)
 { 
  unsigned char stan,znak,liczba,ruch;
  unsigned char licznik,licznik_x, licznik_y;
  struct Jednostka *jednostki_ktore;

  ruch=stan=licznik=licznik_x=licznik_y=liczba=0;
  komunikacja_timer=timeout;
  jednostki_ktore=jednostki_moje;

  while(1)
   {
    //Reakcja na odbior znaku
    if(UCSRA&0x80)
	 {
	  znak=UDR;
	  switch(stan)
	   {
	    case 0:
        if(znak=='!') licznik=0,stan=1;
		break;

        case 1:
		licznik++;
		if(licznik==2) licznik_x=0,licznik_y=0,stan=2;
		break;

		case 2:
        if(znak>='0' && znak<='9') mapa[licznik_x][licznik_y]=znak-'0'-1;
		else
		 { 
		  if(znak>='A' && znak<='F') mapa[licznik_x][licznik_y]=(znak-'A')+0x0a;
		  else return(255);
         }
		licznik_x++;
		if(licznik_x==MAPA_X) stan=3;
		break;

		case 3:
        licznik_x=0;
		licznik_y++;
		licznik=1;
		if(licznik_y==MAPA_Y) stan=5;
		else stan=4;
		break;

		case 4:
		licznik++;
		if(licznik==2) stan=2;
		break;

		case 5:
        if(znak=='@') jednostki_ktore=jednostki_moje,licznik=0,stan=6;
		break;

        case 6:
		licznik++;
		if(licznik==2) licznik_x=0,stan=7;
		break;

		case 7:
		if(znak>='0' && znak<='9')  liczba=(znak-'0')<<4,stan=8;
		else
		 {
		  if(znak>='A' && znak<='F') liczba=(znak-'A'+0x0a)<<4,stan=8;
		  else
		   {
		    licznik=0;
		    if(znak=='#') jednostki_ktore=jednostki_wroga,stan=6;
		    else
		     {
		      if(znak=='$') stan=12;
			  else return(255);
             }
           }
         }
		break;

		case 8:
		if(znak>='0' && znak<='9') liczba=(znak-'0')+liczba;
		else
		 {
		  if(znak>='A' && znak<='F') liczba=(znak-'A'+0x0a)+liczba;
		  else return(255);
         }
		stan=9;
		break; 

		case 9:
		switch(licznik_x)
		 {
		  case 0: if(liczba<ILOSC_JEDNOSTEK) licznik_y=liczba;
		          else return(255); break;
		  case 1: jednostki_ktore[licznik_y].aktywnosc=liczba; break;
		  case 2: jednostki_ktore[licznik_y].typ=liczba; break;
		  case 3: jednostki_ktore[licznik_y].x=liczba; break;
		  case 4: jednostki_ktore[licznik_y].y=liczba; break;
		  case 5: jednostki_ktore[licznik_y].obrona=liczba; break;
		  case 6: jednostki_ktore[licznik_y].atak=liczba; break;
		  case 7: jednostki_ktore[licznik_y].krok=liczba; break;
		 }
        licznik_x++;
		if(licznik_x==8) licznik=1,stan=6;
		else stan=7;
		if(znak!=':' && znak!='\r') return(255);
		break;

        case 12:
		licznik++;
		if(licznik==2) stan=13;
		break;

        case 13:
		if(znak>='0' && znak<='9') ruch=(znak-'0')<<4,stan=14;
		
		break;

		case 14:
		if(znak>='0' && znak<='9') ruch=ruch+(znak-'0'),licznik=0,stan=15;
		else return(255);
		break;

        case 15:
		licznik++;
		if(licznik==2) stan=16;
		break;

		case 16:
		if(znak=='%') licznik=0,stan=17;
		else return(255);
		break;

		case 17:
		licznik++;
		if(licznik==2) return(ruch);
	   }
	 }
    //Sprawdz Timeout
    if(!komunikacja_timer) return(255);
   }
 }
//-------------------------------------------------------------------------------------------------

void komunikacja_wyslij(unsigned char pozycja)
 {
  UCSRA|=0x40;
  UDR=pozycja+'0';
  while(!(UCSRA&0x40));
  UCSRA|=0x40;
  UDR='\n';
  while(!(UCSRA&0x40));
  UCSRA|=0x40;
  UDR='\r';
  while(!(UCSRA&0x40));
 }
//-------------------------------------------------------------------------------------------------
